///////////////////////////////////////////////////////////
//  IEntityHistory.cs
//  Implementation of the Interface IEntityHistory
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:16:39
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityHistory;
using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataInterface;
namespace Org.OMG.TACSIT.DataInterface {
	/// <summary>
	/// This interface access to the history of an entity.
	/// </summary>
	public interface IEntityHistory {

		/// <summary>
		/// Get the payload of the history filtered on the date (no history before this
		/// date will be returned).
		/// </summary>
		/// <param name="filter"></param>
		Org.OMG.TACSIT.DataPayload.EntityHistory.EntityHistoryPayload GetTimeSpan(Org.OMG.TACSIT.DataPayload.Util.Period filter);

		/// <summary>
		/// Get the payload of the history sampled with a 'maxPoints' maximum number of
		/// points.
		///        If 'fromStart' is false, the les than 'maxPoints' most recent data are
		/// returned.
		///        Otherwise, an equal distribution of 'maxPoints' data taken among the
		/// known points is returned.
		/// </summary>
		/// <param name="maxPoints"></param>
		/// <param name="fromStart"></param>
		Org.OMG.TACSIT.DataPayload.EntityHistory.EntityHistoryPayload GetHistorySampling(int maxPoints, bool fromStart);

		/// <summary>
		/// Get back the matching Entity interface.
		/// </summary>
		Org.OMG.TACSIT.DataInterface.IEntity GetEntity();

		/// <summary>
		/// Get the number of data in the history.
		/// </summary>
		int GetLength();

		/// <summary>
		/// Get the date of the first data in the history.
		/// </summary>
		DateTime GetHistoryStart();
	}//end IEntityHistory

}//end namespace DataInterface